torchrun \
  --nproc_per_node=8 \
  train.py \
  --cfg-path lavis/projects/blip/train/vqav2_ft.yaml \
  --options \
    model.freeze_vit=True \
    run.batch_size_train=32 \
    run.wandb.name="BLIP-Prompt-8-8-lr-5e-6" \
    run.lora.enable=False \
    run.init_lr=5e-6

torchrun \
  --nproc_per_node=8 \
  train.py \
  --cfg-path lavis/projects/blip/train/vqav2_ft.yaml \
  --options \
    model.freeze_vit=True \
    run.batch_size_train=32 \
    run.wandb.name="BLIP-Prompt-8-8-lr-1e-6" \
    run.lora.enable=False \
    run.init_lr=1e-6

torchrun \
  --nproc_per_node=8 \
  train.py \
  --cfg-path lavis/projects/blip/train/vqav2_ft.yaml \
  --options \
    model.freeze_vit=True \
    run.batch_size_train=32 \
    run.wandb.name="BLIP-Prompt-8-8-lr-1e-5" \
    run.lora.enable=False \
    run.init_lr=1e-5

torchrun \
  --nproc_per_node=8 \
  train.py \
  --cfg-path lavis/projects/blip/train/vqav2_ft.yaml \
  --options \
    model.freeze_vit=True \
    model.use_grad_checkpoint=True \
    env.cache_root="~/dataset/BLIP/" \
    run.batch_size_train=80 \
    run.batch_size_eval=16 \
    run.wandb.name="BLIP-Prompt-100-50-lr-5e-5" \
    run.lora.enable=False \
    run.max_epoch=5 \
    run.init_lr=5e-5 \
    run.prompt_tuning.text_encoder.token_num=100 \
    run.prompt_tuning.text_decoder.token_num=50

torchrun \
  --nproc_per_node=8 \
  train.py \
  --cfg-path lavis/projects/blip/train/vqav2_ft.yaml \
  --options \
    run.batch_size_train=128 \
    model.use_grad_checkpoint=True \
    run.batch_size_eval=32 \
    run.wandb.name="BLIP-LoRA-All-lr-1e-5" \
    run.lora.enable=True \
    run.prompt_tuning.enable=False \
    run.init_lr=1e-5

torchrun \
  --nproc_per_node=8 \
  train.py \
  --cfg-path lavis/projects/blip/train/vqav2_ft.yaml \
  --options \
    run.batch_size_train=32 \
    run.batch_size_eval=16 \
    run.wandb.name="BLIP-Finetune-lr-2e-5" \
    run.lora.enable=False \
    run.prompt_tuning.enable=False \
    run.init_lr=2e-5

CUDA_VISIBLE_DEVICES=0 \
  python \
  train.py \
  --cfg-path lavis/projects/blip/train/vqav2_ft.yaml \
  --options \
    model.freeze_vit=True \
    model.use_grad_checkpoint=True \
    run.batch_size_train=300 \
    run.batch_size_eval=32 \
    run.wandb.name="BLIP-Prompt-100-50-lr-5e-5" \
    run.lora.enable=False \
    run.max_epoch=4 \
    run.init_lr=5e-5 \
    run.prompt_tuning.text_encoder.token_num=100 \
    run.prompt_tuning.text_decoder.token_num=50

CUDA_VISIBLE_DEVICES=1 \
  python \
  train.py \
  --cfg-path lavis/projects/blip/train/vqav2_ft.yaml \
  --options \
    model.freeze_vit=True \
    model.use_grad_checkpoint=True \
    run.batch_size_train=300 \
    run.batch_size_eval=32 \
    run.wandb.name="BLIP-Prompt-100-10-lr-5e-5" \
    run.lora.enable=False \
    run.max_epoch=4 \
    run.init_lr=5e-5 \
    run.prompt_tuning.text_encoder.token_num=100 \
    run.prompt_tuning.text_decoder.token_num=10

CUDA_VISIBLE_DEVICES=2 \
  python \
  train.py \
  --cfg-path lavis/projects/blip/train/vqav2_ft.yaml \
  --options \
    model.freeze_vit=True \
    model.use_grad_checkpoint=True \
    run.batch_size_train=500 \
    run.batch_size_eval=32 \
    run.wandb.name="BLIP-Prompt-50-10-lr-5e-5" \
    run.lora.enable=False \
    run.max_epoch=4 \
    run.init_lr=5e-5 \
    run.prompt_tuning.text_encoder.token_num=30 \
    run.prompt_tuning.text_decoder.token_num=10


CUDA_VISIBLE_DEVICES=3 \
  python \
  train.py \
  --cfg-path lavis/projects/blip/train/vqav2_ft.yaml \
  --options \
    model.freeze_vit=True \
    model.use_grad_checkpoint=True \
    run.batch_size_train=600 \
    run.batch_size_eval=32 \
    run.wandb.name="BLIP-Prompt-50-0-lr-5e-5" \
    run.lora.enable=False \
    run.max_epoch=4 \
    run.init_lr=5e-5 \
    run.prompt_tuning.text_encoder.token_num=50 \
    run.prompt_tuning.text_decoder.enable=False



CUDA_VISIBLE_DEVICES=3 \
  python \
  train.py \
  --cfg-path lavis/projects/blip/train/vqav2_ft.yaml \
  --options \
    model.freeze_vit=True \
    model.use_grad_checkpoint=True \
    run.batch_size_train=600 \
    run.batch_size_eval=32 \
    run.wandb.name="BLIP-Prompt-50-0-lr-5e-5" \
    run.lora.enable=False \
    run.max_epoch=4 \
    run.init_lr=5e-5 \
    run.prompt_tuning.text_encoder.enable=False \
    run.prompt_tuning.text_decoder.token_num=50